# -*- coding: utf-8 -*-

"""
neutrinoapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from neutrinoapi.api_helper import APIHelper
from neutrinoapi.models.location import Location


class GeocodeAddressResponse(object):

    """Implementation of the 'GeocodeAddressResponse' model.

    Structure of geocode-address

    Attributes:
        found (int): The number of possible matching locations found
        locations (List[Location]): Array of matching location objects
        additional_properties (Dict[str, Any]): The additional properties for
            the model.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "found": 'found',
        "locations": 'locations'
    }

    def __init__(self,
                 found=None,
                 locations=None,
                 additional_properties=None):
        """Constructor for the GeocodeAddressResponse class"""

        # Initialize members of the class
        self.found = found 
        self.locations = locations 

        # Add additional model properties to the instance
        if additional_properties is None:
            additional_properties = {}
        self.additional_properties = additional_properties

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        found = dictionary.get("found") if dictionary.get("found") else None
        locations = None
        if dictionary.get('locations') is not None:
            locations = [Location.from_dictionary(x) for x in dictionary.get('locations')]
        additional_properties = APIHelper.get_additional_properties(
            dictionary={k: v for k, v in dictionary.items() if k not in cls._names.values()},
            unboxing_function=lambda value: value)
        # Return an object of this model
        return cls(found,
                   locations,
                   additional_properties)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'found={self.found!r}, '
                f'locations={self.locations!r}, '
                f'additional_properties={self.additional_properties!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'found={self.found!s}, '
                f'locations={self.locations!s}, '
                f'additional_properties={self.additional_properties!s})')
