# -*- coding: utf-8 -*-

"""
neutrinoapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from neutrinoapi.api_helper import APIHelper


class PhonePlaybackResponse(object):

    """Implementation of the 'PhonePlaybackResponse' model.

    Structure of phone-playback

    Attributes:
        calling (bool): True if the call is being made now
        number_valid (bool): True if this a valid phone number
        additional_properties (Dict[str, Any]): The additional properties for
            the model.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "calling": 'calling',
        "number_valid": 'number-valid'
    }

    def __init__(self,
                 calling=None,
                 number_valid=None,
                 additional_properties=None):
        """Constructor for the PhonePlaybackResponse class"""

        # Initialize members of the class
        self.calling = calling 
        self.number_valid = number_valid 

        # Add additional model properties to the instance
        if additional_properties is None:
            additional_properties = {}
        self.additional_properties = additional_properties

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        calling = dictionary.get("calling") if "calling" in dictionary.keys() else None
        number_valid = dictionary.get("number-valid") if "number-valid" in dictionary.keys() else None
        additional_properties = APIHelper.get_additional_properties(
            dictionary={k: v for k, v in dictionary.items() if k not in cls._names.values()},
            unboxing_function=lambda value: value)
        # Return an object of this model
        return cls(calling,
                   number_valid,
                   additional_properties)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'calling={self.calling!r}, '
                f'number_valid={self.number_valid!r}, '
                f'additional_properties={self.additional_properties!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'calling={self.calling!s}, '
                f'number_valid={self.number_valid!s}, '
                f'additional_properties={self.additional_properties!s})')
